-- Specjalizacja dla Bizon Z020 --
-- Autor: Rockstar94 --
-- Data: 03-12-2015 --



Zagon = {};

function Zagon.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Combine, specializations);
end;

function Zagon:load(savegame)
    if self.isClient then
        self.sieczkarniaParticleSystems = {};
        local i=0;
        while true do
            local baseName = string.format("vehicle.sieczkarniaParticleSystems.sieczkarniaParticleSystem(%d)", i);

            local particleSystem = {};
            particleSystem.ps = {};
            local ps = Utils.loadParticleSystem(xmlFile, particleSystem.ps, baseName, self.components, false, nil, self.baseDirectory)
            if ps == nil then
                break;
            end;
            table.insert(self.sieczkarniaParticleSystems, particleSystem);
            i = i+1;
        end;
    end;
    
    local near_pipe = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.near_pipe#index"));
    if near_pipe ~= nil then
        self.near_pipe = near_pipe;
    end;
    
    local near_zaczep = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.zaczep#index"));
    if near_zaczep ~= nil then
        self.near_zaczep = near_zaczep;
    end;
    
    self.sprezyny_vis = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.sprezyny_vis#index"));
    setVisibility((self.sprezyny_vis), false);
    
    self.strzalka_vis = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.strzalka_vis#index"));
    setVisibility((self.strzalka_vis), false);
    
    hudraulika_SoundFile = Utils.getFilename("Dzwieki/skret.wav", self.baseDirectory);
    self.hudraulika_SoundId = createSample("Hydraulika");
    loadSample(self.hudraulika_SoundId, hudraulika_SoundFile, false);
    
    wysypywanie_SoundFile = Utils.getFilename("Dzwieki/sypanie.wav", self.baseDirectory);
    self.wysypywanie_SoundId = createSample("Wysypywanie");
    loadSample(self.wysypywanie_SoundId, wysypywanie_SoundFile, false);
    
    wysypywanie_pusto_SoundFile = Utils.getFilename("Dzwieki/sypanie_pusto.wav", self.baseDirectory);
    self.wysypywanie_pusto_SoundId = createSample("Wysypywanie_pusto");
    loadSample(self.wysypywanie_pusto_SoundId, wysypywanie_pusto_SoundFile, false);
end;

function Zagon:delete()
    if self.isClient then
        for k, v in pairs(self.sieczkarniaParticleSystems) do
            Utils.deleteParticleSystem(v.ps)
        end;
        
        if self.hydr_sound ~= nil then
            delete(self.hudraulika_SoundId)
        end;    
        
        if self.wysyp_sound ~= nil then
            delete(self.wysypywanie_SoundId)
        end;
        
        if self.wysyp_pusto_sound ~= nil then
            delete(self.wysypywanie_pusto_SoundId)
        end;
    end;
end;

function Zagon:keyEvent(unicode, sym, modifier, isDown)
 end;
 
function Zagon:update(dt)    
    if self.isTurnedOn then
        self:setAnimationTime(1, 1);
        for k,v in ipairs(self.sieczkarniaParticleSystems) do
            Utils.setEmittingState(v.ps, true);
        end;
    else
        self:setAnimationTime(1, 0);
        for k,v in ipairs(self.sieczkarniaParticleSystems) do
            Utils.setEmittingState(v.ps, false);
        end;
    end;
    
    local nearestDistance = 1;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.near_pipe);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
        if distance < nearestDistance then
            self.przy_rurze = true;
        else
            self.przy_rurze = false;
        end;
        
    if self.przy_rurze then
        if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
            if self.animationParts[2].clipEndTime then
                self:setAnimationTime(2, self.animationParts[2].offSet);
            elseif self.animationParts[2].clipStartTime  then
                self:setAnimationTime(2, self.animationParts[2].animDuration);    
            end;
        end;
        if self.animationParts[2].clipStartTime then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Dump_corn")), InputBinding.IMPLEMENT_EXTRA2);
        else
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Pipe_in")), InputBinding.IMPLEMENT_EXTRA2);
        end;
    end;
    
    if self.animationParts[2].clipEndTime then
        self.currentPipeState = 2;
        self.targetPipeState = 2;
    else
        self.currentPipeState = 1;
        self.targetPipeState = 1;
        self:setAnimationTime(6, self.animationParts[6].offSet);    
        self:setAnimationTime(7, 0);
    end;
    
    if self.currentPipeState == 2 and self.targetPipeState == 2 then
        if self:getIsActiveForInput(self.needsSelection) and not self:hasInputConflictWithSelection() then
            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
                if self.animationParts[6].clipEndTime then
                    self:setAnimationTime(6, self.animationParts[6].offSet);
                elseif self.animationParts[6].clipStartTime  then
                    self:setAnimationTime(6, self.animationParts[6].animDuration);    
                end;
            end;
            if self.animationParts[6].clipStartTime then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Start_overloading")), InputBinding.IMPLEMENT_EXTRA2);
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Stop_overloading")), InputBinding.IMPLEMENT_EXTRA2);
            end;
        end;
        if not self:getIsActiveForSound() then
            if self.wysyp_sound then
                stopSample(self.wysypywanie_SoundId);
                self.wysyp_sound = false;
            end;
            if self.wysyp_pusto_sound then
                stopSample(self.wysypywanie_pusto_SoundId);
                self.wysyp_pusto_sound = false;
            end;
        end;
        if self.animationParts[6].clipStartTime then
            if self.wysyp_sound then
                stopSample(self.wysypywanie_SoundId);
                self.wysyp_sound = false;
            end;
            if self.wysyp_pusto_sound then
                stopSample(self.wysypywanie_pusto_SoundId);
                self.wysyp_pusto_sound = false;
            end;
            self:setAnimationTime(7, 0);
        elseif self.animationParts[6].clipEndTime  then
            if self:getIsActiveForSound() then
                if self.pipeIsUnloading then
                    if not self.wysyp_sound then
                        playSample(self.wysypywanie_SoundId, 0, 0.4, 0);
                        self.wysyp_sound = true;
                    end;
                    if self.wysyp_pusto_sound then
                        stopSample(self.wysypywanie_pusto_SoundId);
                        self.wysyp_pusto_sound = false;
                    end;
                else
                    if not self.wysyp_pusto_sound then
                        playSample(self.wysypywanie_pusto_SoundId, 0, 0.4, 0);
                        self.wysyp_pusto_sound = true;
                    end;
                    if self.wysyp_sound then
                        stopSample(self.wysypywanie_SoundId);
                        self.wysyp_sound = false;
                    end;
                end;
            end;
            self:setAnimationTime(7, 1);
        end;
    else
        if self.wysyp_sound then
            stopSample(self.wysypywanie_SoundId);
            self.wysyp_sound = false;
        end;
        if self.wysyp_pusto_sound then
            stopSample(self.wysypywanie_pusto_SoundId);
            self.wysyp_pusto_sound = false;
        end;
    end;
    
    if self.isClient then
        if self.currentFillType == Fillable.FILLTYPE_WHEAT or self.currentFillType == Fillable.FILLTYPE_BARLEY then
            self.isStrawEnabled = true;
        end;
        if self.numAttachedCutters > 0 then
            if self:getIsActiveForSound() and self:getIsActive() then
                if Input.isKeyPressed(Input.KEY_m) then
                    self:setAnimationTime(4, self.animationParts[4].currentPosition+(self.animationParts[4].offSet+dt), false);
                elseif Input.isKeyPressed(Input.KEY_k) then
                    self:setAnimationTime(4, self.animationParts[4].currentPosition-(self.animationParts[4].offSet+dt), false);
                end;
                if Input.isKeyPressed(Input.KEY_m) or Input.isKeyPressed(Input.KEY_n) or Input.isKeyPressed(Input.KEY_j) then
                    if not self.hydr_sound then
                        playSample(self.hudraulika_SoundId, 0, 0.3, 0);
                        self.hydr_sound = true;
                    end;
                else
                    if self.hydr_sound then
                        stopSample(self.hudraulika_SoundId);
                        self.hydr_sound = false;
                    end;
                end;
            end;
            setVisibility((self.sprezyny_vis), true);
        else
            if self.hydr_sound then
                stopSample(self.hudraulika_SoundId);
                self.hydr_sound = false;
            end;
            setVisibility((self.sprezyny_vis), false);
        end;
    end;
    
    local nearestDistance = 0.75;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.near_zaczep);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
        if distance < nearestDistance then
            self.przy_zaczep = true;
        else
            self.przy_zaczep = false;
        end;
        
    if self.przy_zaczep then
        if Input.isKeyPressed(Input.KEY_j) then
            self:setAnimationTime(3, self.animationParts[3].currentPosition+(self.animationParts[3].offSet+dt), false);
        elseif Input.isKeyPressed(Input.KEY_n) then
            self:setAnimationTime(3, self.animationParts[3].currentPosition-(self.animationParts[3].offSet+dt), false);
        end;
        if Input.isKeyPressed(Input.KEY_m) then
            self:setAnimationTime(5, self.animationParts[5].currentPosition+(self.animationParts[5].offSet+dt), false);
        elseif Input.isKeyPressed(Input.KEY_k) then
            self:setAnimationTime(5, self.animationParts[5].currentPosition-(self.animationParts[5].offSet+dt), false);
        end;
        g_currentMission:addExtraPrintText(g_i18n:getText("info_zaczep"));
        g_currentMission:addExtraPrintText(g_i18n:getText("info_zaczep_1"));
        setVisibility((self.strzalka_vis), true);
    else
        setVisibility((self.strzalka_vis), false);
    end;
end;

function Zagon:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Zagon:validateAttacherJoint(implement, jointDesc, dt)
return true;
end;

function Zagon:draw()
    if self.isClient and self:getIsActiveForInput(true) then
        if self.numAttachedCutters > 0 then
            g_currentMission:addExtraPrintText(g_i18n:getText("info_heder"));
            g_currentMission:addExtraPrintText(g_i18n:getText("info_heder_1"));
        else
            g_currentMission:addExtraPrintText(g_i18n:getText("info_heder_brak"));
        end;
        if self.animationParts[2].clipStartTime and Input.isKeyPressed(Input.KEY_o) then
            g_currentMission:showBlinkingWarning(g_i18n:getText("info_rura"), 2000);
        end;
        if self.animationParts[2].clipEndTime and Input.isKeyPressed(Input.KEY_o) then
            g_currentMission:showBlinkingWarning(g_i18n:getText("info_rura_1"), 2000);
        end;
        if self.currentFillType == Fillable.FILLTYPE_WHEAT or self.currentFillType == Fillable.FILLTYPE_BARLEY then
            if Input.isKeyPressed(Input.KEY_comma) and self.isTurnedOn then
                g_currentMission:showBlinkingWarning(g_i18n:getText("info_sieczka"), 2000);
            end;
        end;
    end;
end;