-- Specjalizacja dla Bizon Z020 --
-- Autor: Rockstar94 --
-- Data: 03-12-2015 --



Zagon_heder = {};

function Zagon_heder.prerequisitesPresent(specializations)
    return true
end;

function Zagon_heder:load(savegame)
    if self.isClient then
        self.hederParticleSystems = {};
        local i=0;
        while true do
            local baseName = string.format("vehicle.hederParticleSystems.hederParticleSystem(%d)", i);

            local particleSystem = {};
            particleSystem.ps = {};
            local ps = Utils.loadParticleSystem(xmlFile, particleSystem.ps, baseName, self.components, false, nil, self.baseDirectory)
            if ps == nil then
                break;
            end;
            table.insert(self.hederParticleSystems, particleSystem);
            i = i+1;
        end;
    end;
    
    local oslona = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.przy_oslonie#index"));
    if oslona ~= nil then
        self.oslona = oslona;
    end;
    
    self.oslona_vis = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Oslona_vis#index"));
    setVisibility((self.oslona_vis), true);
end;

function Zagon_heder:delete()
    if self.isClient then
        for k, v in pairs(self.hederParticleSystems) do
            Utils.deleteParticleSystem(v.ps)
        end;
    end;
end;

function Zagon_heder:keyEvent(unicode, sym, modifier, isDown)
 end;
 
function Zagon_heder:update(dt)    
    if self.reelStarted then    
        self:setAnimationTime(1, 1);
        for k,v in ipairs(self.hederParticleSystems) do
            Utils.setEmittingState(v.ps, true);
        end;
    else
        self:setAnimationTime(1, 0);
        for k,v in ipairs(self.hederParticleSystems) do
            Utils.setEmittingState(v.ps, false);
        end;
    end;
    
    if self:getIsActiveForSound() and self:getIsActive() then
        if Input.isKeyPressed(Input.KEY_n) then
            self:setAnimationTime(2, self.animationParts[2].currentPosition+(self.animationParts[2].offSet+dt), false);
        elseif Input.isKeyPressed(Input.KEY_j) then
            self:setAnimationTime(2, self.animationParts[2].currentPosition-(self.animationParts[2].offSet+dt), false);
        end;
    end;
    
    local nearestDistance = 0.75;
    local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
    local px, py, pz = getWorldTranslation(self.oslona);
    local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
        if distance < nearestDistance then
            self.przy_oslona = true;
        else
            self.przy_oslona = false;
        end;
    
    if self.przy_oslona then
        if not self.reelStarted then
            if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
                self.oslona_act = not self.oslona_act;
            end;
            if self.oslona_act then
                g_currentMission:addHelpButtonText(g_i18n:getText("oslona_1"), InputBinding.IMPLEMENT_EXTRA2);
            else
                g_currentMission:addHelpButtonText(g_i18n:getText("oslona"), InputBinding.IMPLEMENT_EXTRA2);
            end;
        else
            if self.oslona_act then
                g_currentMission:addExtraPrintText(g_i18n:getText("oslona_2"));
            else
                g_currentMission:addExtraPrintText(g_i18n:getText("oslona_3"));
            end;
        end;
    end;
    
    if self.oslona_act then
        setVisibility(self.oslona_vis,true);
    else
        setVisibility(self.oslona_vis,false);
    end;
end;

function Zagon_heder:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Zagon_heder:validateAttacherJoint(implement, jointDesc, dt)
return true;
end;

function Zagon_heder:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    if not resetVehicles then        
        local oslona_act = getXMLBool(xmlFile, key.."#oslona_act");
        
        if oslona_act ~= nil then
            self.oslona_act = oslona_act;
        end;
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function Zagon_heder:getSaveAttributesAndNodes(nodeIdent)
    if self.oslona_act then
        oslona_act = "true";
    else
        oslona_act = "false";
    end;
    
    local attributes = string.format('oslona_act="%s"',oslona_act);
    return attributes,nodes;
end;

function Zagon_heder:draw()
    if self.isClient and self:getIsActiveForInput(true) then
        g_currentMission:addExtraPrintText(g_i18n:getText("info_heder"));
        g_currentMission:addExtraPrintText(g_i18n:getText("info_heder_1"));
    end;
end;